﻿Imports System
Imports System.Text
Imports System.Web.UI
Imports Microsoft.IdentityModel.Claims
Imports Microsoft.SharePoint.Utilities

Namespace Microsoft.Sample.ContentWeb.ClaimsSecurity
    Partial Public Class ClaimsView
        Inherits UserControl
        Public Overloads Overrides Sub RenderControl(ByVal writer As HtmlTextWriter)
            MyBase.RenderControl(writer)
            Try
                Using ClaimsScope As New SPMonitoredScope("Microsoft.Sample.ContentWeb.WebParts.ClaimsWebPart.ClaimsWebPart")
                    'look for the claims identity
                    Dim cp As IClaimsPrincipal = TryCast(Page.User, IClaimsPrincipal)

                    If cp IsNot Nothing Then
                        'get the claims identity so we can enum claims
                        Dim ci As IClaimsIdentity = CType(cp.Identity, IClaimsIdentity)

                        writer.AddStyleAttribute(HtmlTextWriterStyle.BorderStyle, "solid")
                        writer.AddStyleAttribute(HtmlTextWriterStyle.BorderWidth, "1px")
                        writer.RenderBeginTag(HtmlTextWriterTag.Table)
                        writer.RenderBeginTag(HtmlTextWriterTag.Tr)
                        writer.AddAttribute(HtmlTextWriterAttribute.Colspan, "2")
                        writer.AddStyleAttribute(HtmlTextWriterStyle.FontWeight, "bold")
                        writer.RenderBeginTag(HtmlTextWriterTag.Td)
                        writer.WriteEncodedText("The following claims were found in this request:")
                        writer.RenderEndTag() ' td
                        writer.RenderEndTag() ' tr

                        'enumerate all claims
                        For Each claim As Claim In ci.Claims
                            RenderRow(writer, claim)
                        Next claim

                        writer.RenderEndTag() ' table
                    End If
                End Using
            Catch ex As Exception
                writer.Write("<b>There was an error rendering claims: " & ex.Message & "</b>")
            End Try
        End Sub

        Private Sub RenderRow(ByVal writer As HtmlTextWriter, ByVal claim As Claim)
            writer.RenderBeginTag(HtmlTextWriterTag.Tr)
            writer.RenderBeginTag(HtmlTextWriterTag.Td)
            writer.WriteEncodedText(StringTrim(claim.ClaimType.ToString(), 80))
            writer.RenderEndTag() ' td
            writer.RenderBeginTag(HtmlTextWriterTag.Td)
            writer.WriteEncodedText(StringTrim(claim.Value.ToString(), 60))
            writer.RenderEndTag() ' td
            writer.RenderEndTag() ' tr
        End Sub

        Private Function StringTrim(ByVal str As String, ByVal length As Integer) As String
            If str.Length > length Then
                Dim sbuilder As New StringBuilder(length * 2)
                sbuilder.Append(str.Substring(0, length - 3))
                sbuilder.Append("...")
                Return sbuilder.ToString()
            End If
            Return str.PadRight(length, " "c)
        End Function
    End Class
End Namespace