﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Imports Microsoft.SharePoint.Administration
Imports System.Diagnostics.CodeAnalysis

Namespace Microsoft.Sample.ContentWeb.ClaimsSecurity
    ''' <summary>
    ''' Data Access class for custom claims.
    ''' </summary>
    Friend Class CustomClaimSourceDA
        ''' <summary>
        ''' Connects to custom claim cource ContentWebAdminDB database to retrieve user claims.
        ''' </summary>
        ''' <param name="alias">user's alias</param>
        ''' <returns>A dataset of simple and compound claim tables.</returns>

        <SuppressMessage("Microsoft.Reliability", "CA2000:DisposeObjectsBeforeLosingScope", Justification:="Low priority")> _
        Public Shared Function GetUserClaims(ByVal [alias] As String, ByVal connectionString As String) As DataSet
            Dim dataSet As New DataSet("UserClaims")
            Dim cmd As New SqlCommand()
            cmd.CommandType = CommandType.StoredProcedure
            cmd.CommandText = "dbo.GetUserClaims"

            cmd.Connection = New SqlConnection(connectionString)

            ' Adding input params...
            cmd.Parameters.Add(New SqlParameter("@alias", SqlDbType.NVarChar, 256)).Value = [alias]

            Using cmd.Connection
                Dim adapter As New SqlDataAdapter()

                cmd.Connection.Open()
                adapter.SelectCommand = cmd

                ' Fill the DataSet.
                adapter.Fill(dataSet)
            End Using

            Return dataSet
        End Function
    End Class
End Namespace