Imports System
Imports System.Runtime.InteropServices
Imports System.Security.Permissions
Imports Microsoft.SharePoint
Imports Microsoft.SharePoint.Security
Imports Microsoft.SharePoint.Administration.Claims

Namespace Microsoft.Sample.ContentWeb.ClaimsSecurity.Features.ClaimsSecurityFeature
    <SharePointPermission(System.Security.Permissions.SecurityAction.Demand, ObjectModel:=True), Guid("760b783d-56b6-44ce-9e39-926a426121fb")> _
 Public Class ClaimsSecurityFeatureEventReceiver
        Inherits SPClaimProviderFeatureReceiver
        Public Overrides ReadOnly Property ClaimProviderAssembly() As String
            Get
                Return GetType(ContentWebClaimProvider).Assembly.FullName
            End Get
        End Property

        Public Overrides ReadOnly Property ClaimProviderDescription() As String
            Get
                Return "This feature adds ContentWeb claim types/values in the security token"
            End Get
        End Property

        Public Overrides ReadOnly Property ClaimProviderDisplayName() As String
            Get
                Return "ContentWeb Claim Provider"
            End Get
        End Property

        Public Overrides ReadOnly Property ClaimProviderType() As String
            Get
                Return GetType(ContentWebClaimProvider).FullName
            End Get
        End Property

        ''' <summary>
        ''' This methods gets called after the activation of the feature.
        ''' </summary>

        ''' <param name="properties">Represents the properties of a feature activation<./param>
        ''' <returns>void.</returns>
        Public Overrides Sub FeatureActivated(ByVal properties As Microsoft.SharePoint.SPFeatureReceiverProperties)
            ExecBaseFeatureActivated(properties)
        End Sub

        ''' <summary>
        ''' Because use of base keywork can lead to unverifiable code inside lambda expression, 
        ''' this function is created as a wrapper for the base.FeatureActivated function.
        ''' This function gets called in the following lambda expression.
        ''' </summary>

        ''' <param name="properties">Represents the properties of a feature activation.</param>
        ''' <returns> void </returns>
        Private Sub ExecBaseFeatureActivated(ByVal properties As Microsoft.SharePoint.SPFeatureReceiverProperties)
            MyBase.FeatureActivated(properties)
        End Sub
    End Class
End Namespace